"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Rx = __importStar(require("rxjs"));
const operators_1 = require("rxjs/operators");
const types_1 = require("../../types");
const debug = __importStar(require("../../debug"));
const fetch_1 = require("./fetch");
const cleanEvents_1 = require("../../utils/cleanEvents");
const createSnapshot = (options, orders) => ({
    event: types_1.NormalizedMessageType.SNAPSHOT,
    exchange: types_1.Exchange.KYBER_NETWORK,
    network: options.network,
    base: options.pair.base,
    quote: options.pair.quote,
    orders,
});
const pollRate = (options, currencies) => {
    const base = options.pair.base.symbol;
    const quote = options.pair.quote.symbol;
    return Rx.interval(5000).pipe(operators_1.tap(() => {
        debug.log(`Loading snapshot for market %s-%s.`, base, quote);
    }), operators_1.switchMap(() => fetch_1.fetchRates(options, currencies)), operators_1.retryWhen(error => error.pipe(operators_1.delay(10000))), operators_1.distinctUntilChanged());
};
exports.watch = (options) => {
    const rates$ = Rx.from(fetch_1.fetchCurrencies(options)).pipe(operators_1.retryWhen(error => error.pipe(operators_1.delay(10000))), operators_1.switchMap(currencies => pollRate(options, currencies)));
    return rates$.pipe(operators_1.map(orders => createSnapshot(options, orders)), operators_1.tap(event => debug.log('Source event: %e', event)), cleanEvents_1.cleanEvents(), operators_1.tap(event => debug.log('Output event: %e', event)));
};
